// --------------------------------------------------------
//     DGMBZ.INC
//     Dave G's Multi-Bezier Curve System
//     Include file for POV-RAY 3.0
// --------------------------------------------------------
//
//     Copyright (C) 1997
//        David Govoni
//        E-mail: david.govoni@sympatico.ca
//
//           Please contact me with any:
//              comments, suggestions, changes,
//              and success stories. If you
//              create any wonderful animations or images
//              I would like to know about them.
//
//     Version
//        0.95 Beta - March 22nd, 1997
//
// --------------------------------------------------------
// Documentation is in:
//   DGBZ.PDF - Adobe Acrobat Format
//
// --------------------------------------------------------
// This file is freely distributable and useable as long
// as all files in this archive are kept together.
// --------------------------------------------------------
// If you make changes or additions to this file, please
// put your name, the date, and a description of the
// changes into the file. If you feel the changes should
// be added to later releases of this file, please tell me
// about your modifications.
// --------------------------------------------------------
//
//
//
//
// --------------------------------------------------------
// Declare all variable not set by the user to their defaults
#ifndef (DGMBZCurves)      #declare DGMBZLength      = 0             #end
#ifndef (DGMBZPosition)    #declare DGMBZPosition    = <0,0,0>       #end
#ifndef (DGMBZAmount)      #declare DGMBZAmount      = 0             #end
#ifndef (DGMBZ01C0)        #declare DGMBZ01C0        = <-5,0,0>      #end
#ifndef (DGMBZ01C1)        #declare DGMBZ01C1        = <-3,3,0>      #end
#ifndef (DGMBZ01C2)        #declare DGMBZ01C2        = < 3,3,0>      #end
#ifndef (DGMBZ01C3)        #declare DGMBZ01C3        = < 5,0,0>      #end
#ifndef (DGMBZ02C0)        #declare DGMBZ02C0        = <-5,0,0>      #end
#ifndef (DGMBZ02C1)        #declare DGMBZ02C1        = <-3,3,0>      #end
#ifndef (DGMBZ02C2)        #declare DGMBZ02C2        = < 3,3,0>      #end
#ifndef (DGMBZ02C3)        #declare DGMBZ02C3        = < 5,0,0>      #end
#ifndef (DGMBZ03C0)        #declare DGMBZ03C0        = <-5,0,0>      #end
#ifndef (DGMBZ03C1)        #declare DGMBZ03C1        = <-3,3,0>      #end
#ifndef (DGMBZ03C2)        #declare DGMBZ03C2        = < 3,3,0>      #end
#ifndef (DGMBZ03C3)        #declare DGMBZ03C3        = < 5,0,0>      #end
#ifndef (DGMBZ04C0)        #declare DGMBZ04C0        = <-5,0,0>      #end
#ifndef (DGMBZ04C1)        #declare DGMBZ04C1        = <-3,3,0>      #end
#ifndef (DGMBZ04C2)        #declare DGMBZ04C2        = < 3,3,0>      #end
#ifndef (DGMBZ04C3)        #declare DGMBZ04C3        = < 5,0,0>      #end
#ifndef (DGMBZ05C0)        #declare DGMBZ05C0        = <-5,0,0>      #end
#ifndef (DGMBZ05C1)        #declare DGMBZ05C1        = <-3,3,0>      #end
#ifndef (DGMBZ05C2)        #declare DGMBZ05C2        = < 3,3,0>      #end
#ifndef (DGMBZ05C3)        #declare DGMBZ05C3        = < 5,0,0>      #end
#ifndef (DGMBZ06C0)        #declare DGMBZ06C0        = <-5,0,0>      #end
#ifndef (DGMBZ06C1)        #declare DGMBZ06C1        = <-3,3,0>      #end
#ifndef (DGMBZ06C2)        #declare DGMBZ06C2        = < 3,3,0>      #end
#ifndef (DGMBZ06C3)        #declare DGMBZ06C3        = < 5,0,0>      #end
#ifndef (DGMBZ07C0)        #declare DGMBZ07C0        = <-5,0,0>      #end
#ifndef (DGMBZ07C1)        #declare DGMBZ07C1        = <-3,3,0>      #end
#ifndef (DGMBZ07C2)        #declare DGMBZ07C2        = < 3,3,0>      #end
#ifndef (DGMBZ07C3)        #declare DGMBZ07C3        = < 5,0,0>      #end
#ifndef (DGMBZ08C0)        #declare DGMBZ08C0        = <-5,0,0>      #end
#ifndef (DGMBZ08C1)        #declare DGMBZ08C1        = <-3,3,0>      #end
#ifndef (DGMBZ08C2)        #declare DGMBZ08C2        = < 3,3,0>      #end
#ifndef (DGMBZ08C3)        #declare DGMBZ08C3        = < 5,0,0>      #end
#ifndef (DGMBZ09C0)        #declare DGMBZ09C0        = <-5,0,0>      #end
#ifndef (DGMBZ09C1)        #declare DGMBZ09C1        = <-3,3,0>      #end
#ifndef (DGMBZ09C2)        #declare DGMBZ09C2        = < 3,3,0>      #end
#ifndef (DGMBZ09C3)        #declare DGMBZ09C3        = < 5,0,0>      #end
#ifndef (DGMBZ10C0)        #declare DGMBZ10C0        = <-5,0,0>      #end
#ifndef (DGMBZ10C1)        #declare DGMBZ10C1        = <-3,3,0>      #end
#ifndef (DGMBZ10C2)        #declare DGMBZ10C2        = < 3,3,0>      #end
#ifndef (DGMBZ10C3)        #declare DGMBZ10C3        = < 5,0,0>      #end
#ifndef (DGMBZ11C0)        #declare DGMBZ11C0        = <-5,0,0>      #end
#ifndef (DGMBZ11C1)        #declare DGMBZ11C1        = <-3,3,0>      #end
#ifndef (DGMBZ11C2)        #declare DGMBZ11C2        = < 3,3,0>      #end
#ifndef (DGMBZ11C3)        #declare DGMBZ11C3        = < 5,0,0>      #end
#ifndef (DGMBZ12C0)        #declare DGMBZ12C0        = <-5,0,0>      #end
#ifndef (DGMBZ12C1)        #declare DGMBZ12C1        = <-3,3,0>      #end
#ifndef (DGMBZ12C2)        #declare DGMBZ12C2        = < 3,3,0>      #end
#ifndef (DGMBZ12C3)        #declare DGMBZ12C3        = < 5,0,0>      #end
#ifndef (DGMBZ13C0)        #declare DGMBZ13C0        = <-5,0,0>      #end
#ifndef (DGMBZ13C1)        #declare DGMBZ13C1        = <-3,3,0>      #end
#ifndef (DGMBZ13C2)        #declare DGMBZ13C2        = < 3,3,0>      #end
#ifndef (DGMBZ13C3)        #declare DGMBZ13C3        = < 5,0,0>      #end
#ifndef (DGMBZ14C0)        #declare DGMBZ14C0        = <-5,0,0>      #end
#ifndef (DGMBZ14C1)        #declare DGMBZ14C1        = <-3,3,0>      #end
#ifndef (DGMBZ14C2)        #declare DGMBZ14C2        = < 3,3,0>      #end
#ifndef (DGMBZ14C3)        #declare DGMBZ14C3        = < 5,0,0>      #end
#ifndef (DGMBZ15C0)        #declare DGMBZ15C0        = <-5,0,0>      #end
#ifndef (DGMBZ15C1)        #declare DGMBZ15C1        = <-3,3,0>      #end
#ifndef (DGMBZ15C2)        #declare DGMBZ15C2        = < 3,3,0>      #end
#ifndef (DGMBZ15C3)        #declare DGMBZ15C3        = < 5,0,0>      #end
#ifndef (DGMBZ16C0)        #declare DGMBZ16C0        = <-5,0,0>      #end
#ifndef (DGMBZ16C1)        #declare DGMBZ16C1        = <-3,3,0>      #end
#ifndef (DGMBZ16C2)        #declare DGMBZ16C2        = < 3,3,0>      #end
#ifndef (DGMBZ16C3)        #declare DGMBZ16C3        = < 5,0,0>      #end
#ifndef (DGMBZ17C0)        #declare DGMBZ17C0        = <-5,0,0>      #end
#ifndef (DGMBZ17C1)        #declare DGMBZ17C1        = <-3,3,0>      #end
#ifndef (DGMBZ17C2)        #declare DGMBZ17C2        = < 3,3,0>      #end
#ifndef (DGMBZ17C3)        #declare DGMBZ17C3        = < 5,0,0>      #end
#ifndef (DGMBZ18C0)        #declare DGMBZ18C0        = <-5,0,0>      #end
#ifndef (DGMBZ18C1)        #declare DGMBZ18C1        = <-3,3,0>      #end
#ifndef (DGMBZ18C2)        #declare DGMBZ18C2        = < 3,3,0>      #end
#ifndef (DGMBZ18C3)        #declare DGMBZ18C3        = < 5,0,0>      #end
#ifndef (DGMBZ19C0)        #declare DGMBZ19C0        = <-5,0,0>      #end
#ifndef (DGMBZ19C1)        #declare DGMBZ19C1        = <-3,3,0>      #end
#ifndef (DGMBZ19C2)        #declare DGMBZ19C2        = < 3,3,0>      #end
#ifndef (DGMBZ19C3)        #declare DGMBZ19C3        = < 5,0,0>      #end
#ifndef (DGMBZ20C0)        #declare DGMBZ20C0        = <-5,0,0>      #end
#ifndef (DGMBZ20C1)        #declare DGMBZ20C1        = <-3,3,0>      #end
#ifndef (DGMBZ20C2)        #declare DGMBZ20C2        = < 3,3,0>      #end
#ifndef (DGMBZ20C3)        #declare DGMBZ20C3        = < 5,0,0>      #end
#ifndef (DGMBZ21C0)        #declare DGMBZ21C0        = <-5,0,0>      #end
#ifndef (DGMBZ21C1)        #declare DGMBZ21C1        = <-3,3,0>      #end
#ifndef (DGMBZ21C2)        #declare DGMBZ21C2        = < 3,3,0>      #end
#ifndef (DGMBZ21C3)        #declare DGMBZ21C3        = < 5,0,0>      #end
#ifndef (DGMBZ22C0)        #declare DGMBZ22C0        = <-5,0,0>      #end
#ifndef (DGMBZ22C1)        #declare DGMBZ22C1        = <-3,3,0>      #end
#ifndef (DGMBZ22C2)        #declare DGMBZ22C2        = < 3,3,0>      #end
#ifndef (DGMBZ22C3)        #declare DGMBZ22C3        = < 5,0,0>      #end
#ifndef (DGMBZ23C0)        #declare DGMBZ23C0        = <-5,0,0>      #end
#ifndef (DGMBZ23C1)        #declare DGMBZ23C1        = <-3,3,0>      #end
#ifndef (DGMBZ23C2)        #declare DGMBZ23C2        = < 3,3,0>      #end
#ifndef (DGMBZ23C3)        #declare DGMBZ23C3        = < 5,0,0>      #end
#ifndef (DGMBZ24C0)        #declare DGMBZ24C0        = <-5,0,0>      #end
#ifndef (DGMBZ24C1)        #declare DGMBZ24C1        = <-3,3,0>      #end
#ifndef (DGMBZ24C2)        #declare DGMBZ24C2        = < 3,3,0>      #end
#ifndef (DGMBZ24C3)        #declare DGMBZ24C3        = < 5,0,0>      #end
#ifndef (DGMBZ25C0)        #declare DGMBZ25C0        = <-5,0,0>      #end
#ifndef (DGMBZ25C1)        #declare DGMBZ25C1        = <-3,3,0>      #end
#ifndef (DGMBZ25C2)        #declare DGMBZ25C2        = < 3,3,0>      #end
#ifndef (DGMBZ25C3)        #declare DGMBZ25C3        = < 5,0,0>      #end
#ifndef (DGMBZ26C0)        #declare DGMBZ26C0        = <-5,0,0>      #end
#ifndef (DGMBZ26C1)        #declare DGMBZ26C1        = <-3,3,0>      #end
#ifndef (DGMBZ26C2)        #declare DGMBZ26C2        = < 3,3,0>      #end
#ifndef (DGMBZ26C3)        #declare DGMBZ26C3        = < 5,0,0>      #end
#ifndef (DGMBZ27C0)        #declare DGMBZ27C0        = <-5,0,0>      #end
#ifndef (DGMBZ27C1)        #declare DGMBZ27C1        = <-3,3,0>      #end
#ifndef (DGMBZ27C2)        #declare DGMBZ27C2        = < 3,3,0>      #end
#ifndef (DGMBZ27C3)        #declare DGMBZ27C3        = < 5,0,0>      #end
#ifndef (DGMBZ28C0)        #declare DGMBZ28C0        = <-5,0,0>      #end
#ifndef (DGMBZ28C1)        #declare DGMBZ28C1        = <-3,3,0>      #end
#ifndef (DGMBZ28C2)        #declare DGMBZ28C2        = < 3,3,0>      #end
#ifndef (DGMBZ28C3)        #declare DGMBZ28C3        = < 5,0,0>      #end
#ifndef (DGMBZ29C0)        #declare DGMBZ29C0        = <-5,0,0>      #end
#ifndef (DGMBZ29C1)        #declare DGMBZ29C1        = <-3,3,0>      #end
#ifndef (DGMBZ29C2)        #declare DGMBZ29C2        = < 3,3,0>      #end
#ifndef (DGMBZ29C3)        #declare DGMBZ29C3        = < 5,0,0>      #end
#ifndef (DGMBZ30C0)        #declare DGMBZ30C0        = <-5,0,0>      #end
#ifndef (DGMBZ30C1)        #declare DGMBZ30C1        = <-3,3,0>      #end
#ifndef (DGMBZ30C2)        #declare DGMBZ30C2        = < 3,3,0>      #end
#ifndef (DGMBZ30C3)        #declare DGMBZ30C3        = < 5,0,0>      #end
#ifndef (DGMBZ31C0)        #declare DGMBZ31C0        = <-5,0,0>      #end
#ifndef (DGMBZ31C1)        #declare DGMBZ31C1        = <-3,3,0>      #end
#ifndef (DGMBZ31C2)        #declare DGMBZ31C2        = < 3,3,0>      #end
#ifndef (DGMBZ31C3)        #declare DGMBZ31C3        = < 5,0,0>      #end
#ifndef (DGMBZ32C0)        #declare DGMBZ32C0        = <-5,0,0>      #end
#ifndef (DGMBZ32C1)        #declare DGMBZ32C1        = <-3,3,0>      #end
#ifndef (DGMBZ32C2)        #declare DGMBZ32C2        = < 3,3,0>      #end
#ifndef (DGMBZ32C3)        #declare DGMBZ32C3        = < 5,0,0>      #end
#ifndef (DGMBZ33C0)        #declare DGMBZ33C0        = <-5,0,0>      #end
#ifndef (DGMBZ33C1)        #declare DGMBZ33C1        = <-3,3,0>      #end
#ifndef (DGMBZ33C2)        #declare DGMBZ33C2        = < 3,3,0>      #end
#ifndef (DGMBZ33C3)        #declare DGMBZ33C3        = < 5,0,0>      #end
#ifndef (DGMBZ34C0)        #declare DGMBZ34C0        = <-5,0,0>      #end
#ifndef (DGMBZ34C1)        #declare DGMBZ34C1        = <-3,3,0>      #end
#ifndef (DGMBZ34C2)        #declare DGMBZ34C2        = < 3,3,0>      #end
#ifndef (DGMBZ34C3)        #declare DGMBZ34C3        = < 5,0,0>      #end
#ifndef (DGMBZ35C0)        #declare DGMBZ35C0        = <-5,0,0>      #end
#ifndef (DGMBZ35C1)        #declare DGMBZ35C1        = <-3,3,0>      #end
#ifndef (DGMBZ35C2)        #declare DGMBZ35C2        = < 3,3,0>      #end
#ifndef (DGMBZ35C3)        #declare DGMBZ35C3        = < 5,0,0>      #end
#ifndef (DGMBZ36C0)        #declare DGMBZ36C0        = <-5,0,0>      #end
#ifndef (DGMBZ36C1)        #declare DGMBZ36C1        = <-3,3,0>      #end
#ifndef (DGMBZ36C2)        #declare DGMBZ36C2        = < 3,3,0>      #end
#ifndef (DGMBZ36C3)        #declare DGMBZ36C3        = < 5,0,0>      #end
#ifndef (DGMBZ37C0)        #declare DGMBZ37C0        = <-5,0,0>      #end
#ifndef (DGMBZ37C1)        #declare DGMBZ37C1        = <-3,3,0>      #end
#ifndef (DGMBZ37C2)        #declare DGMBZ37C2        = < 3,3,0>      #end
#ifndef (DGMBZ37C3)        #declare DGMBZ37C3        = < 5,0,0>      #end
#ifndef (DGMBZ38C0)        #declare DGMBZ38C0        = <-5,0,0>      #end
#ifndef (DGMBZ38C1)        #declare DGMBZ38C1        = <-3,3,0>      #end
#ifndef (DGMBZ38C2)        #declare DGMBZ38C2        = < 3,3,0>      #end
#ifndef (DGMBZ38C3)        #declare DGMBZ38C3        = < 5,0,0>      #end
#ifndef (DGMBZ39C0)        #declare DGMBZ39C0        = <-5,0,0>      #end
#ifndef (DGMBZ39C1)        #declare DGMBZ39C1        = <-3,3,0>      #end
#ifndef (DGMBZ39C2)        #declare DGMBZ39C2        = < 3,3,0>      #end
#ifndef (DGMBZ39C3)        #declare DGMBZ39C3        = < 5,0,0>      #end
#ifndef (DGMBZ40C0)        #declare DGMBZ40C0        = <-5,0,0>      #end
#ifndef (DGMBZ40C1)        #declare DGMBZ40C1        = <-3,3,0>      #end
#ifndef (DGMBZ40C2)        #declare DGMBZ40C2        = < 3,3,0>      #end
#ifndef (DGMBZ40C3)        #declare DGMBZ40C3        = < 5,0,0>      #end
#ifndef (DGMBZ41C0)        #declare DGMBZ41C0        = <-5,0,0>      #end
#ifndef (DGMBZ41C1)        #declare DGMBZ41C1        = <-3,3,0>      #end
#ifndef (DGMBZ41C2)        #declare DGMBZ41C2        = < 3,3,0>      #end
#ifndef (DGMBZ41C3)        #declare DGMBZ41C3        = < 5,0,0>      #end
#ifndef (DGMBZ42C0)        #declare DGMBZ42C0        = <-5,0,0>      #end
#ifndef (DGMBZ42C1)        #declare DGMBZ42C1        = <-3,3,0>      #end
#ifndef (DGMBZ42C2)        #declare DGMBZ42C2        = < 3,3,0>      #end
#ifndef (DGMBZ42C3)        #declare DGMBZ42C3        = < 5,0,0>      #end
#ifndef (DGMBZ43C0)        #declare DGMBZ43C0        = <-5,0,0>      #end
#ifndef (DGMBZ43C1)        #declare DGMBZ43C1        = <-3,3,0>      #end
#ifndef (DGMBZ43C2)        #declare DGMBZ43C2        = < 3,3,0>      #end
#ifndef (DGMBZ43C3)        #declare DGMBZ43C3        = < 5,0,0>      #end
#ifndef (DGMBZ44C0)        #declare DGMBZ44C0        = <-5,0,0>      #end
#ifndef (DGMBZ44C1)        #declare DGMBZ44C1        = <-3,3,0>      #end
#ifndef (DGMBZ44C2)        #declare DGMBZ44C2        = < 3,3,0>      #end
#ifndef (DGMBZ44C3)        #declare DGMBZ44C3        = < 5,0,0>      #end
#ifndef (DGMBZ45C0)        #declare DGMBZ45C0        = <-5,0,0>      #end
#ifndef (DGMBZ45C1)        #declare DGMBZ45C1        = <-3,3,0>      #end
#ifndef (DGMBZ45C2)        #declare DGMBZ45C2        = < 3,3,0>      #end
#ifndef (DGMBZ45C3)        #declare DGMBZ45C3        = < 5,0,0>      #end
#ifndef (DGMBZ46C0)        #declare DGMBZ46C0        = <-5,0,0>      #end
#ifndef (DGMBZ46C1)        #declare DGMBZ46C1        = <-3,3,0>      #end
#ifndef (DGMBZ46C2)        #declare DGMBZ46C2        = < 3,3,0>      #end
#ifndef (DGMBZ46C3)        #declare DGMBZ46C3        = < 5,0,0>      #end
#ifndef (DGMBZ47C0)        #declare DGMBZ47C0        = <-5,0,0>      #end
#ifndef (DGMBZ47C1)        #declare DGMBZ47C1        = <-3,3,0>      #end
#ifndef (DGMBZ47C2)        #declare DGMBZ47C2        = < 3,3,0>      #end
#ifndef (DGMBZ47C3)        #declare DGMBZ47C3        = < 5,0,0>      #end
#ifndef (DGMBZ48C0)        #declare DGMBZ48C0        = <-5,0,0>      #end
#ifndef (DGMBZ48C1)        #declare DGMBZ48C1        = <-3,3,0>      #end
#ifndef (DGMBZ48C2)        #declare DGMBZ48C2        = < 3,3,0>      #end
#ifndef (DGMBZ48C3)        #declare DGMBZ48C3        = < 5,0,0>      #end
#ifndef (DGMBZ49C0)        #declare DGMBZ49C0        = <-5,0,0>      #end
#ifndef (DGMBZ49C1)        #declare DGMBZ49C1        = <-3,3,0>      #end
#ifndef (DGMBZ49C2)        #declare DGMBZ49C2        = < 3,3,0>      #end
#ifndef (DGMBZ49C3)        #declare DGMBZ49C3        = < 5,0,0>      #end
#ifndef (DGMBZ50C0)        #declare DGMBZ50C0        = <-5,0,0>      #end
#ifndef (DGMBZ50C1)        #declare DGMBZ50C1        = <-3,3,0>      #end
#ifndef (DGMBZ50C2)        #declare DGMBZ50C2        = < 3,3,0>      #end
#ifndef (DGMBZ50C3)        #declare DGMBZ50C3        = < 5,0,0>      #end
#ifndef (DGMBZ51C0)        #declare DGMBZ51C0        = <-5,0,0>      #end
#ifndef (DGMBZ51C1)        #declare DGMBZ51C1        = <-3,3,0>      #end
#ifndef (DGMBZ51C2)        #declare DGMBZ51C2        = < 3,3,0>      #end
#ifndef (DGMBZ51C3)        #declare DGMBZ51C3        = < 5,0,0>      #end
#ifndef (DGMBZ52C0)        #declare DGMBZ52C0        = <-5,0,0>      #end
#ifndef (DGMBZ52C1)        #declare DGMBZ52C1        = <-3,3,0>      #end
#ifndef (DGMBZ52C2)        #declare DGMBZ52C2        = < 3,3,0>      #end
#ifndef (DGMBZ52C3)        #declare DGMBZ52C3        = < 5,0,0>      #end
#ifndef (DGMBZ53C0)        #declare DGMBZ53C0        = <-5,0,0>      #end
#ifndef (DGMBZ53C1)        #declare DGMBZ53C1        = <-3,3,0>      #end
#ifndef (DGMBZ53C2)        #declare DGMBZ53C2        = < 3,3,0>      #end
#ifndef (DGMBZ53C3)        #declare DGMBZ53C3        = < 5,0,0>      #end
#ifndef (DGMBZ54C0)        #declare DGMBZ54C0        = <-5,0,0>      #end
#ifndef (DGMBZ54C1)        #declare DGMBZ54C1        = <-3,3,0>      #end
#ifndef (DGMBZ54C2)        #declare DGMBZ54C2        = < 3,3,0>      #end
#ifndef (DGMBZ54C3)        #declare DGMBZ54C3        = < 5,0,0>      #end
#ifndef (DGMBZ55C0)        #declare DGMBZ55C0        = <-5,0,0>      #end
#ifndef (DGMBZ55C1)        #declare DGMBZ55C1        = <-3,3,0>      #end
#ifndef (DGMBZ55C2)        #declare DGMBZ55C2        = < 3,3,0>      #end
#ifndef (DGMBZ55C3)        #declare DGMBZ55C3        = < 5,0,0>      #end
#ifndef (DGMBZ56C0)        #declare DGMBZ56C0        = <-5,0,0>      #end
#ifndef (DGMBZ56C1)        #declare DGMBZ56C1        = <-3,3,0>      #end
#ifndef (DGMBZ56C2)        #declare DGMBZ56C2        = < 3,3,0>      #end
#ifndef (DGMBZ56C3)        #declare DGMBZ56C3        = < 5,0,0>      #end
#ifndef (DGMBZ57C0)        #declare DGMBZ57C0        = <-5,0,0>      #end
#ifndef (DGMBZ57C1)        #declare DGMBZ57C1        = <-3,3,0>      #end
#ifndef (DGMBZ57C2)        #declare DGMBZ57C2        = < 3,3,0>      #end
#ifndef (DGMBZ57C3)        #declare DGMBZ57C3        = < 5,0,0>      #end
#ifndef (DGMBZ58C0)        #declare DGMBZ58C0        = <-5,0,0>      #end
#ifndef (DGMBZ58C1)        #declare DGMBZ58C1        = <-3,3,0>      #end
#ifndef (DGMBZ58C2)        #declare DGMBZ58C2        = < 3,3,0>      #end
#ifndef (DGMBZ58C3)        #declare DGMBZ58C3        = < 5,0,0>      #end
#ifndef (DGMBZ59C0)        #declare DGMBZ59C0        = <-5,0,0>      #end
#ifndef (DGMBZ59C1)        #declare DGMBZ59C1        = <-3,3,0>      #end
#ifndef (DGMBZ59C2)        #declare DGMBZ59C2        = < 3,3,0>      #end
#ifndef (DGMBZ59C3)        #declare DGMBZ59C3        = < 5,0,0>      #end
#ifndef (DGMBZ60C0)        #declare DGMBZ60C0        = <-5,0,0>      #end
#ifndef (DGMBZ60C1)        #declare DGMBZ60C1        = <-3,3,0>      #end
#ifndef (DGMBZ60C2)        #declare DGMBZ60C2        = < 3,3,0>      #end
#ifndef (DGMBZ60C3)        #declare DGMBZ60C3        = < 5,0,0>      #end
#ifndef (DGMBZ61C0)        #declare DGMBZ61C0        = <-5,0,0>      #end
#ifndef (DGMBZ61C1)        #declare DGMBZ61C1        = <-3,3,0>      #end
#ifndef (DGMBZ61C2)        #declare DGMBZ61C2        = < 3,3,0>      #end
#ifndef (DGMBZ61C3)        #declare DGMBZ61C3        = < 5,0,0>      #end
#ifndef (DGMBZ62C0)        #declare DGMBZ62C0        = <-5,0,0>      #end
#ifndef (DGMBZ62C1)        #declare DGMBZ62C1        = <-3,3,0>      #end
#ifndef (DGMBZ62C2)        #declare DGMBZ62C2        = < 3,3,0>      #end
#ifndef (DGMBZ62C3)        #declare DGMBZ62C3        = < 5,0,0>      #end
#ifndef (DGMBZ63C0)        #declare DGMBZ63C0        = <-5,0,0>      #end
#ifndef (DGMBZ63C1)        #declare DGMBZ63C1        = <-3,3,0>      #end
#ifndef (DGMBZ63C2)        #declare DGMBZ63C2        = < 3,3,0>      #end
#ifndef (DGMBZ63C3)        #declare DGMBZ63C3        = < 5,0,0>      #end
#ifndef (DGMBZ64C0)        #declare DGMBZ64C0        = <-5,0,0>      #end
#ifndef (DGMBZ64C1)        #declare DGMBZ64C1        = <-3,3,0>      #end
#ifndef (DGMBZ64C2)        #declare DGMBZ64C2        = < 3,3,0>      #end
#ifndef (DGMBZ64C3)        #declare DGMBZ64C3        = < 5,0,0>      #end
#ifndef (DGMBZ65C0)        #declare DGMBZ65C0        = <-5,0,0>      #end
#ifndef (DGMBZ65C1)        #declare DGMBZ65C1        = <-3,3,0>      #end
#ifndef (DGMBZ65C2)        #declare DGMBZ65C2        = < 3,3,0>      #end
#ifndef (DGMBZ65C3)        #declare DGMBZ65C3        = < 5,0,0>      #end
#ifndef (DGMBZ66C0)        #declare DGMBZ66C0        = <-5,0,0>      #end
#ifndef (DGMBZ66C1)        #declare DGMBZ66C1        = <-3,3,0>      #end
#ifndef (DGMBZ66C2)        #declare DGMBZ66C2        = < 3,3,0>      #end
#ifndef (DGMBZ66C3)        #declare DGMBZ66C3        = < 5,0,0>      #end
#ifndef (DGMBZ67C0)        #declare DGMBZ67C0        = <-5,0,0>      #end
#ifndef (DGMBZ67C1)        #declare DGMBZ67C1        = <-3,3,0>      #end
#ifndef (DGMBZ67C2)        #declare DGMBZ67C2        = < 3,3,0>      #end
#ifndef (DGMBZ67C3)        #declare DGMBZ67C3        = < 5,0,0>      #end
#ifndef (DGMBZ68C0)        #declare DGMBZ68C0        = <-5,0,0>      #end
#ifndef (DGMBZ68C1)        #declare DGMBZ68C1        = <-3,3,0>      #end
#ifndef (DGMBZ68C2)        #declare DGMBZ68C2        = < 3,3,0>      #end
#ifndef (DGMBZ68C3)        #declare DGMBZ68C3        = < 5,0,0>      #end
#ifndef (DGMBZ69C0)        #declare DGMBZ69C0        = <-5,0,0>      #end
#ifndef (DGMBZ69C1)        #declare DGMBZ69C1        = <-3,3,0>      #end
#ifndef (DGMBZ69C2)        #declare DGMBZ69C2        = < 3,3,0>      #end
#ifndef (DGMBZ69C3)        #declare DGMBZ69C3        = < 5,0,0>      #end
#ifndef (DGMBZ70C0)        #declare DGMBZ70C0        = <-5,0,0>      #end
#ifndef (DGMBZ70C1)        #declare DGMBZ70C1        = <-3,3,0>      #end
#ifndef (DGMBZ70C2)        #declare DGMBZ70C2        = < 3,3,0>      #end
#ifndef (DGMBZ70C3)        #declare DGMBZ70C3        = < 5,0,0>      #end
#ifndef (DGMBZ71C0)        #declare DGMBZ71C0        = <-5,0,0>      #end
#ifndef (DGMBZ71C1)        #declare DGMBZ71C1        = <-3,3,0>      #end
#ifndef (DGMBZ71C2)        #declare DGMBZ71C2        = < 3,3,0>      #end
#ifndef (DGMBZ71C3)        #declare DGMBZ71C3        = < 5,0,0>      #end
#ifndef (DGMBZ72C0)        #declare DGMBZ72C0        = <-5,0,0>      #end
#ifndef (DGMBZ72C1)        #declare DGMBZ72C1        = <-3,3,0>      #end
#ifndef (DGMBZ72C2)        #declare DGMBZ72C2        = < 3,3,0>      #end
#ifndef (DGMBZ72C3)        #declare DGMBZ72C3        = < 5,0,0>      #end
#ifndef (DGMBZ73C0)        #declare DGMBZ73C0        = <-5,0,0>      #end
#ifndef (DGMBZ73C1)        #declare DGMBZ73C1        = <-3,3,0>      #end
#ifndef (DGMBZ73C2)        #declare DGMBZ73C2        = < 3,3,0>      #end
#ifndef (DGMBZ73C3)        #declare DGMBZ73C3        = < 5,0,0>      #end
#ifndef (DGMBZ74C0)        #declare DGMBZ74C0        = <-5,0,0>      #end
#ifndef (DGMBZ74C1)        #declare DGMBZ74C1        = <-3,3,0>      #end
#ifndef (DGMBZ74C2)        #declare DGMBZ74C2        = < 3,3,0>      #end
#ifndef (DGMBZ74C3)        #declare DGMBZ74C3        = < 5,0,0>      #end
#ifndef (DGMBZ75C0)        #declare DGMBZ75C0        = <-5,0,0>      #end
#ifndef (DGMBZ75C1)        #declare DGMBZ75C1        = <-3,3,0>      #end
#ifndef (DGMBZ75C2)        #declare DGMBZ75C2        = < 3,3,0>      #end
#ifndef (DGMBZ75C3)        #declare DGMBZ75C3        = < 5,0,0>      #end
#ifndef (DGMBZ76C0)        #declare DGMBZ76C0        = <-5,0,0>      #end
#ifndef (DGMBZ76C1)        #declare DGMBZ76C1        = <-3,3,0>      #end
#ifndef (DGMBZ76C2)        #declare DGMBZ76C2        = < 3,3,0>      #end
#ifndef (DGMBZ76C3)        #declare DGMBZ76C3        = < 5,0,0>      #end
#ifndef (DGMBZ77C0)        #declare DGMBZ77C0        = <-5,0,0>      #end
#ifndef (DGMBZ77C1)        #declare DGMBZ77C1        = <-3,3,0>      #end
#ifndef (DGMBZ77C2)        #declare DGMBZ77C2        = < 3,3,0>      #end
#ifndef (DGMBZ77C3)        #declare DGMBZ77C3        = < 5,0,0>      #end
#ifndef (DGMBZ78C0)        #declare DGMBZ78C0        = <-5,0,0>      #end
#ifndef (DGMBZ78C1)        #declare DGMBZ78C1        = <-3,3,0>      #end
#ifndef (DGMBZ78C2)        #declare DGMBZ78C2        = < 3,3,0>      #end
#ifndef (DGMBZ78C3)        #declare DGMBZ78C3        = < 5,0,0>      #end
#ifndef (DGMBZ79C0)        #declare DGMBZ79C0        = <-5,0,0>      #end
#ifndef (DGMBZ79C1)        #declare DGMBZ79C1        = <-3,3,0>      #end
#ifndef (DGMBZ79C2)        #declare DGMBZ79C2        = < 3,3,0>      #end
#ifndef (DGMBZ79C3)        #declare DGMBZ79C3        = < 5,0,0>      #end
#ifndef (DGMBZ80C0)        #declare DGMBZ80C0        = <-5,0,0>      #end
#ifndef (DGMBZ80C1)        #declare DGMBZ80C1        = <-3,3,0>      #end
#ifndef (DGMBZ80C2)        #declare DGMBZ80C2        = < 3,3,0>      #end
#ifndef (DGMBZ80C3)        #declare DGMBZ80C3        = < 5,0,0>      #end
#ifndef (DGMBZ81C0)        #declare DGMBZ81C0        = <-5,0,0>      #end
#ifndef (DGMBZ81C1)        #declare DGMBZ81C1        = <-3,3,0>      #end
#ifndef (DGMBZ81C2)        #declare DGMBZ81C2        = < 3,3,0>      #end
#ifndef (DGMBZ81C3)        #declare DGMBZ81C3        = < 5,0,0>      #end
#ifndef (DGMBZ82C0)        #declare DGMBZ82C0        = <-5,0,0>      #end
#ifndef (DGMBZ82C1)        #declare DGMBZ82C1        = <-3,3,0>      #end
#ifndef (DGMBZ82C2)        #declare DGMBZ82C2        = < 3,3,0>      #end
#ifndef (DGMBZ82C3)        #declare DGMBZ82C3        = < 5,0,0>      #end
#ifndef (DGMBZ83C0)        #declare DGMBZ83C0        = <-5,0,0>      #end
#ifndef (DGMBZ83C1)        #declare DGMBZ83C1        = <-3,3,0>      #end
#ifndef (DGMBZ83C2)        #declare DGMBZ83C2        = < 3,3,0>      #end
#ifndef (DGMBZ83C3)        #declare DGMBZ83C3        = < 5,0,0>      #end
#ifndef (DGMBZ84C0)        #declare DGMBZ84C0        = <-5,0,0>      #end
#ifndef (DGMBZ84C1)        #declare DGMBZ84C1        = <-3,3,0>      #end
#ifndef (DGMBZ84C2)        #declare DGMBZ84C2        = < 3,3,0>      #end
#ifndef (DGMBZ84C3)        #declare DGMBZ84C3        = < 5,0,0>      #end
#ifndef (DGMBZ85C0)        #declare DGMBZ85C0        = <-5,0,0>      #end
#ifndef (DGMBZ85C1)        #declare DGMBZ85C1        = <-3,3,0>      #end
#ifndef (DGMBZ85C2)        #declare DGMBZ85C2        = < 3,3,0>      #end
#ifndef (DGMBZ85C3)        #declare DGMBZ85C3        = < 5,0,0>      #end
#ifndef (DGMBZ86C0)        #declare DGMBZ86C0        = <-5,0,0>      #end
#ifndef (DGMBZ86C1)        #declare DGMBZ86C1        = <-3,3,0>      #end
#ifndef (DGMBZ86C2)        #declare DGMBZ86C2        = < 3,3,0>      #end
#ifndef (DGMBZ86C3)        #declare DGMBZ86C3        = < 5,0,0>      #end
#ifndef (DGMBZ87C0)        #declare DGMBZ87C0        = <-5,0,0>      #end
#ifndef (DGMBZ87C1)        #declare DGMBZ87C1        = <-3,3,0>      #end
#ifndef (DGMBZ87C2)        #declare DGMBZ87C2        = < 3,3,0>      #end
#ifndef (DGMBZ87C3)        #declare DGMBZ87C3        = < 5,0,0>      #end
#ifndef (DGMBZ88C0)        #declare DGMBZ88C0        = <-5,0,0>      #end
#ifndef (DGMBZ88C1)        #declare DGMBZ88C1        = <-3,3,0>      #end
#ifndef (DGMBZ88C2)        #declare DGMBZ88C2        = < 3,3,0>      #end
#ifndef (DGMBZ88C3)        #declare DGMBZ88C3        = < 5,0,0>      #end
#ifndef (DGMBZ89C0)        #declare DGMBZ89C0        = <-5,0,0>      #end
#ifndef (DGMBZ89C1)        #declare DGMBZ89C1        = <-3,3,0>      #end
#ifndef (DGMBZ89C2)        #declare DGMBZ89C2        = < 3,3,0>      #end
#ifndef (DGMBZ89C3)        #declare DGMBZ89C3        = < 5,0,0>      #end
#ifndef (DGMBZ90C0)        #declare DGMBZ90C0        = <-5,0,0>      #end
#ifndef (DGMBZ90C1)        #declare DGMBZ90C1        = <-3,3,0>      #end
#ifndef (DGMBZ90C2)        #declare DGMBZ90C2        = < 3,3,0>      #end
#ifndef (DGMBZ90C3)        #declare DGMBZ90C3        = < 5,0,0>      #end
#ifndef (DGMBZ91C0)        #declare DGMBZ91C0        = <-5,0,0>      #end
#ifndef (DGMBZ91C1)        #declare DGMBZ91C1        = <-3,3,0>      #end
#ifndef (DGMBZ91C2)        #declare DGMBZ91C2        = < 3,3,0>      #end
#ifndef (DGMBZ91C3)        #declare DGMBZ91C3        = < 5,0,0>      #end
#ifndef (DGMBZ92C0)        #declare DGMBZ92C0        = <-5,0,0>      #end
#ifndef (DGMBZ92C1)        #declare DGMBZ92C1        = <-3,3,0>      #end
#ifndef (DGMBZ92C2)        #declare DGMBZ92C2        = < 3,3,0>      #end
#ifndef (DGMBZ92C3)        #declare DGMBZ92C3        = < 5,0,0>      #end
#ifndef (DGMBZ93C0)        #declare DGMBZ93C0        = <-5,0,0>      #end
#ifndef (DGMBZ93C1)        #declare DGMBZ93C1        = <-3,3,0>      #end
#ifndef (DGMBZ93C2)        #declare DGMBZ93C2        = < 3,3,0>      #end
#ifndef (DGMBZ93C3)        #declare DGMBZ93C3        = < 5,0,0>      #end
#ifndef (DGMBZ94C0)        #declare DGMBZ94C0        = <-5,0,0>      #end
#ifndef (DGMBZ94C1)        #declare DGMBZ94C1        = <-3,3,0>      #end
#ifndef (DGMBZ94C2)        #declare DGMBZ94C2        = < 3,3,0>      #end
#ifndef (DGMBZ94C3)        #declare DGMBZ94C3        = < 5,0,0>      #end
#ifndef (DGMBZ95C0)        #declare DGMBZ95C0        = <-5,0,0>      #end
#ifndef (DGMBZ95C1)        #declare DGMBZ95C1        = <-3,3,0>      #end
#ifndef (DGMBZ95C2)        #declare DGMBZ95C2        = < 3,3,0>      #end
#ifndef (DGMBZ95C3)        #declare DGMBZ95C3        = < 5,0,0>      #end
#ifndef (DGMBZ96C0)        #declare DGMBZ96C0        = <-5,0,0>      #end
#ifndef (DGMBZ96C1)        #declare DGMBZ96C1        = <-3,3,0>      #end
#ifndef (DGMBZ96C2)        #declare DGMBZ96C2        = < 3,3,0>      #end
#ifndef (DGMBZ96C3)        #declare DGMBZ96C3        = < 5,0,0>      #end
#ifndef (DGMBZ97C0)        #declare DGMBZ97C0        = <-5,0,0>      #end
#ifndef (DGMBZ97C1)        #declare DGMBZ97C1        = <-3,3,0>      #end
#ifndef (DGMBZ97C2)        #declare DGMBZ97C2        = < 3,3,0>      #end
#ifndef (DGMBZ97C3)        #declare DGMBZ97C3        = < 5,0,0>      #end
#ifndef (DGMBZ98C0)        #declare DGMBZ98C0        = <-5,0,0>      #end
#ifndef (DGMBZ98C1)        #declare DGMBZ98C1        = <-3,3,0>      #end
#ifndef (DGMBZ98C2)        #declare DGMBZ98C2        = < 3,3,0>      #end
#ifndef (DGMBZ98C3)        #declare DGMBZ98C3        = < 5,0,0>      #end
#ifndef (DGMBZ99C0)        #declare DGMBZ99C0        = <-5,0,0>      #end
#ifndef (DGMBZ99C1)        #declare DGMBZ99C1        = <-3,3,0>      #end
#ifndef (DGMBZ99C2)        #declare DGMBZ99C2        = < 3,3,0>      #end
#ifndef (DGMBZ99C3)        #declare DGMBZ99C3        = < 5,0,0>      #end
// --------------------------------------------------------


// --------------------------------------------------------
// Check for incorrect data
// --------------------------------------------------------
// 1) The Amount through the curve is not between 0-1
#declare DGMBZAmount = abs(DGMBZAmount)
#while (DGMBZAmount > 1)
	#declare DGMBZAmount = DGMBZAmount - 1
#end
// --------------------------------------------------------
// 2) Check the number of curves is acceptable
#declare DGMBZCurves = abs(DGMBZCurves)
#if (DGMBZCurves > 99)
	#declare DGMBZCurves = 99
#end
// --------------------------------------------------------



// --------------------------------------------------------
// Now on to the actual work of the file
// --------------------------------------------------------

// --------------------------------------------------------
// First determine the total length of the path
// --------------------------------------------------------
#declare DGMBZTotal_Length = 0
// --------------------------------------------------------
#if (DGMBZCurves >= 01)
	// pass the values on to the DGBINT.INC include file
	#declare DGBZINTC0      = DGMBZ01C0
	#declare DGBZINTC1      = DGMBZ01C1
	#declare DGBZINTC2      = DGMBZ01C2
	#declare DGBZINTC3      = DGMBZ01C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength01  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 02)
	#declare DGBZINTC0      = DGMBZ02C0
	#declare DGBZINTC1      = DGMBZ02C1
	#declare DGBZINTC2      = DGMBZ02C2
	#declare DGBZINTC3      = DGMBZ02C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength02  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 03)
	#declare DGBZINTC0      = DGMBZ03C0
	#declare DGBZINTC1      = DGMBZ03C1
	#declare DGBZINTC2      = DGMBZ03C2
	#declare DGBZINTC3      = DGMBZ03C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength03  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 04)
	#declare DGBZINTC0      = DGMBZ04C0
	#declare DGBZINTC1      = DGMBZ04C1
	#declare DGBZINTC2      = DGMBZ04C2
	#declare DGBZINTC3      = DGMBZ04C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength04  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 05)
	#declare DGBZINTC0      = DGMBZ05C0
	#declare DGBZINTC1      = DGMBZ05C1
	#declare DGBZINTC2      = DGMBZ05C2
	#declare DGBZINTC3      = DGMBZ05C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength05  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 06)
	#declare DGBZINTC0      = DGMBZ06C0
	#declare DGBZINTC1      = DGMBZ06C1
	#declare DGBZINTC2      = DGMBZ06C2
	#declare DGBZINTC3      = DGMBZ06C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength06  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 07)
	#declare DGBZINTC0      = DGMBZ07C0
	#declare DGBZINTC1      = DGMBZ07C1
	#declare DGBZINTC2      = DGMBZ07C2
	#declare DGBZINTC3      = DGMBZ07C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength07  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 08)
	#declare DGBZINTC0      = DGMBZ08C0
	#declare DGBZINTC1      = DGMBZ08C1
	#declare DGBZINTC2      = DGMBZ08C2
	#declare DGBZINTC3      = DGMBZ08C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength08  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 09)
	#declare DGBZINTC0      = DGMBZ09C0
	#declare DGBZINTC1      = DGMBZ09C1
	#declare DGBZINTC2      = DGMBZ09C2
	#declare DGBZINTC3      = DGMBZ09C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength09  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 10)
	#declare DGBZINTC0      = DGMBZ10C0
	#declare DGBZINTC1      = DGMBZ10C1
	#declare DGBZINTC2      = DGMBZ10C2
	#declare DGBZINTC3      = DGMBZ10C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength10  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 11)
	#declare DGBZINTC0      = DGMBZ11C0
	#declare DGBZINTC1      = DGMBZ11C1
	#declare DGBZINTC2      = DGMBZ11C2
	#declare DGBZINTC3      = DGMBZ11C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength11  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 12)
	#declare DGBZINTC0      = DGMBZ12C0
	#declare DGBZINTC1      = DGMBZ12C1
	#declare DGBZINTC2      = DGMBZ12C2
	#declare DGBZINTC3      = DGMBZ12C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength12  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 13)
	#declare DGBZINTC0      = DGMBZ13C0
	#declare DGBZINTC1      = DGMBZ13C1
	#declare DGBZINTC2      = DGMBZ13C2
	#declare DGBZINTC3      = DGMBZ13C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength13  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 14)
	#declare DGBZINTC0      = DGMBZ14C0
	#declare DGBZINTC1      = DGMBZ14C1
	#declare DGBZINTC2      = DGMBZ14C2
	#declare DGBZINTC3      = DGMBZ14C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength14  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 15)
	#declare DGBZINTC0      = DGMBZ15C0
	#declare DGBZINTC1      = DGMBZ15C1
	#declare DGBZINTC2      = DGMBZ15C2
	#declare DGBZINTC3      = DGMBZ15C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength15  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 16)
	#declare DGBZINTC0      = DGMBZ16C0
	#declare DGBZINTC1      = DGMBZ16C1
	#declare DGBZINTC2      = DGMBZ16C2
	#declare DGBZINTC3      = DGMBZ16C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength16  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 17)
	#declare DGBZINTC0      = DGMBZ17C0
	#declare DGBZINTC1      = DGMBZ17C1
	#declare DGBZINTC2      = DGMBZ17C2
	#declare DGBZINTC3      = DGMBZ17C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength17  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 18)
	#declare DGBZINTC0      = DGMBZ18C0
	#declare DGBZINTC1      = DGMBZ18C1
	#declare DGBZINTC2      = DGMBZ18C2
	#declare DGBZINTC3      = DGMBZ18C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength18  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 19)
	#declare DGBZINTC0      = DGMBZ19C0
	#declare DGBZINTC1      = DGMBZ19C1
	#declare DGBZINTC2      = DGMBZ19C2
	#declare DGBZINTC3      = DGMBZ19C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength19  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 20)
	#declare DGBZINTC0      = DGMBZ20C0
	#declare DGBZINTC1      = DGMBZ20C1
	#declare DGBZINTC2      = DGMBZ20C2
	#declare DGBZINTC3      = DGMBZ20C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength20  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 21)
	#declare DGBZINTC0      = DGMBZ21C0
	#declare DGBZINTC1      = DGMBZ21C1
	#declare DGBZINTC2      = DGMBZ21C2
	#declare DGBZINTC3      = DGMBZ21C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength21  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 22)
	#declare DGBZINTC0      = DGMBZ22C0
	#declare DGBZINTC1      = DGMBZ22C1
	#declare DGBZINTC2      = DGMBZ22C2
	#declare DGBZINTC3      = DGMBZ22C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength22  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 23)
	#declare DGBZINTC0      = DGMBZ23C0
	#declare DGBZINTC1      = DGMBZ23C1
	#declare DGBZINTC2      = DGMBZ23C2
	#declare DGBZINTC3      = DGMBZ23C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength23  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 24)
	#declare DGBZINTC0      = DGMBZ24C0
	#declare DGBZINTC1      = DGMBZ24C1
	#declare DGBZINTC2      = DGMBZ24C2
	#declare DGBZINTC3      = DGMBZ24C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength24  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 25)
	#declare DGBZINTC0      = DGMBZ25C0
	#declare DGBZINTC1      = DGMBZ25C1
	#declare DGBZINTC2      = DGMBZ25C2
	#declare DGBZINTC3      = DGMBZ25C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength25  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 26)
	#declare DGBZINTC0      = DGMBZ26C0
	#declare DGBZINTC1      = DGMBZ26C1
	#declare DGBZINTC2      = DGMBZ26C2
	#declare DGBZINTC3      = DGMBZ26C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength26  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 27)
	#declare DGBZINTC0      = DGMBZ27C0
	#declare DGBZINTC1      = DGMBZ27C1
	#declare DGBZINTC2      = DGMBZ27C2
	#declare DGBZINTC3      = DGMBZ27C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength27  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 28)
	#declare DGBZINTC0      = DGMBZ28C0
	#declare DGBZINTC1      = DGMBZ28C1
	#declare DGBZINTC2      = DGMBZ28C2
	#declare DGBZINTC3      = DGMBZ28C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength28  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 29)
	#declare DGBZINTC0      = DGMBZ29C0
	#declare DGBZINTC1      = DGMBZ29C1
	#declare DGBZINTC2      = DGMBZ29C2
	#declare DGBZINTC3      = DGMBZ29C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength29  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 30)
	#declare DGBZINTC0      = DGMBZ30C0
	#declare DGBZINTC1      = DGMBZ30C1
	#declare DGBZINTC2      = DGMBZ30C2
	#declare DGBZINTC3      = DGMBZ30C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength30  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 31)
	#declare DGBZINTC0      = DGMBZ31C0
	#declare DGBZINTC1      = DGMBZ31C1
	#declare DGBZINTC2      = DGMBZ31C2
	#declare DGBZINTC3      = DGMBZ31C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength31  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 32)
	#declare DGBZINTC0      = DGMBZ32C0
	#declare DGBZINTC1      = DGMBZ32C1
	#declare DGBZINTC2      = DGMBZ32C2
	#declare DGBZINTC3      = DGMBZ32C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength32  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 33)
	#declare DGBZINTC0      = DGMBZ33C0
	#declare DGBZINTC1      = DGMBZ33C1
	#declare DGBZINTC2      = DGMBZ33C2
	#declare DGBZINTC3      = DGMBZ33C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength33  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 34)
	#declare DGBZINTC0      = DGMBZ34C0
	#declare DGBZINTC1      = DGMBZ34C1
	#declare DGBZINTC2      = DGMBZ34C2
	#declare DGBZINTC3      = DGMBZ34C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength34  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 35)
	#declare DGBZINTC0      = DGMBZ35C0
	#declare DGBZINTC1      = DGMBZ35C1
	#declare DGBZINTC2      = DGMBZ35C2
	#declare DGBZINTC3      = DGMBZ35C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength35  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 36)
	#declare DGBZINTC0      = DGMBZ36C0
	#declare DGBZINTC1      = DGMBZ36C1
	#declare DGBZINTC2      = DGMBZ36C2
	#declare DGBZINTC3      = DGMBZ36C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength36  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 37)
	#declare DGBZINTC0      = DGMBZ37C0
	#declare DGBZINTC1      = DGMBZ37C1
	#declare DGBZINTC2      = DGMBZ37C2
	#declare DGBZINTC3      = DGMBZ37C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength37  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 38)
	#declare DGBZINTC0      = DGMBZ38C0
	#declare DGBZINTC1      = DGMBZ38C1
	#declare DGBZINTC2      = DGMBZ38C2
	#declare DGBZINTC3      = DGMBZ38C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength38  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 39)
	#declare DGBZINTC0      = DGMBZ39C0
	#declare DGBZINTC1      = DGMBZ39C1
	#declare DGBZINTC2      = DGMBZ39C2
	#declare DGBZINTC3      = DGMBZ39C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength39  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 40)
	#declare DGBZINTC0      = DGMBZ40C0
	#declare DGBZINTC1      = DGMBZ40C1
	#declare DGBZINTC2      = DGMBZ40C2
	#declare DGBZINTC3      = DGMBZ40C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength40  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 41)
	#declare DGBZINTC0      = DGMBZ41C0
	#declare DGBZINTC1      = DGMBZ41C1
	#declare DGBZINTC2      = DGMBZ41C2
	#declare DGBZINTC3      = DGMBZ41C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength41  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 42)
	#declare DGBZINTC0      = DGMBZ42C0
	#declare DGBZINTC1      = DGMBZ42C1
	#declare DGBZINTC2      = DGMBZ42C2
	#declare DGBZINTC3      = DGMBZ42C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength42  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 43)
	#declare DGBZINTC0      = DGMBZ43C0
	#declare DGBZINTC1      = DGMBZ43C1
	#declare DGBZINTC2      = DGMBZ43C2
	#declare DGBZINTC3      = DGMBZ43C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength43  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 44)
	#declare DGBZINTC0      = DGMBZ44C0
	#declare DGBZINTC1      = DGMBZ44C1
	#declare DGBZINTC2      = DGMBZ44C2
	#declare DGBZINTC3      = DGMBZ44C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength44  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 45)
	#declare DGBZINTC0      = DGMBZ45C0
	#declare DGBZINTC1      = DGMBZ45C1
	#declare DGBZINTC2      = DGMBZ45C2
	#declare DGBZINTC3      = DGMBZ45C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength45  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 46)
	#declare DGBZINTC0      = DGMBZ46C0
	#declare DGBZINTC1      = DGMBZ46C1
	#declare DGBZINTC2      = DGMBZ46C2
	#declare DGBZINTC3      = DGMBZ46C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength46  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 47)
	#declare DGBZINTC0      = DGMBZ47C0
	#declare DGBZINTC1      = DGMBZ47C1
	#declare DGBZINTC2      = DGMBZ47C2
	#declare DGBZINTC3      = DGMBZ47C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength47  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 48)
	#declare DGBZINTC0      = DGMBZ48C0
	#declare DGBZINTC1      = DGMBZ48C1
	#declare DGBZINTC2      = DGMBZ48C2
	#declare DGBZINTC3      = DGMBZ48C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength48  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 49)
	#declare DGBZINTC0      = DGMBZ49C0
	#declare DGBZINTC1      = DGMBZ49C1
	#declare DGBZINTC2      = DGMBZ49C2
	#declare DGBZINTC3      = DGMBZ49C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength49  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 50)
	#declare DGBZINTC0      = DGMBZ50C0
	#declare DGBZINTC1      = DGMBZ50C1
	#declare DGBZINTC2      = DGMBZ50C2
	#declare DGBZINTC3      = DGMBZ50C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength50  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 51)
	#declare DGBZINTC0      = DGMBZ51C0
	#declare DGBZINTC1      = DGMBZ51C1
	#declare DGBZINTC2      = DGMBZ51C2
	#declare DGBZINTC3      = DGMBZ51C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength51  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 52)
	#declare DGBZINTC0      = DGMBZ52C0
	#declare DGBZINTC1      = DGMBZ52C1
	#declare DGBZINTC2      = DGMBZ52C2
	#declare DGBZINTC3      = DGMBZ52C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength52  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 53)
	#declare DGBZINTC0      = DGMBZ53C0
	#declare DGBZINTC1      = DGMBZ53C1
	#declare DGBZINTC2      = DGMBZ53C2
	#declare DGBZINTC3      = DGMBZ53C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength53  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 54)
	#declare DGBZINTC0      = DGMBZ54C0
	#declare DGBZINTC1      = DGMBZ54C1
	#declare DGBZINTC2      = DGMBZ54C2
	#declare DGBZINTC3      = DGMBZ54C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength54  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 55)
	#declare DGBZINTC0      = DGMBZ55C0
	#declare DGBZINTC1      = DGMBZ55C1
	#declare DGBZINTC2      = DGMBZ55C2
	#declare DGBZINTC3      = DGMBZ55C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength55  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 56)
	#declare DGBZINTC0      = DGMBZ56C0
	#declare DGBZINTC1      = DGMBZ56C1
	#declare DGBZINTC2      = DGMBZ56C2
	#declare DGBZINTC3      = DGMBZ56C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength56  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 57)
	#declare DGBZINTC0      = DGMBZ57C0
	#declare DGBZINTC1      = DGMBZ57C1
	#declare DGBZINTC2      = DGMBZ57C2
	#declare DGBZINTC3      = DGMBZ57C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength57  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 58)
	#declare DGBZINTC0      = DGMBZ58C0
	#declare DGBZINTC1      = DGMBZ58C1
	#declare DGBZINTC2      = DGMBZ58C2
	#declare DGBZINTC3      = DGMBZ58C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength58  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 59)
	#declare DGBZINTC0      = DGMBZ59C0
	#declare DGBZINTC1      = DGMBZ59C1
	#declare DGBZINTC2      = DGMBZ59C2
	#declare DGBZINTC3      = DGMBZ59C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength59  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 60)
	#declare DGBZINTC0      = DGMBZ60C0
	#declare DGBZINTC1      = DGMBZ60C1
	#declare DGBZINTC2      = DGMBZ60C2
	#declare DGBZINTC3      = DGMBZ60C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength60  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 61)
	#declare DGBZINTC0      = DGMBZ61C0
	#declare DGBZINTC1      = DGMBZ61C1
	#declare DGBZINTC2      = DGMBZ61C2
	#declare DGBZINTC3      = DGMBZ61C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength61  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 62)
	#declare DGBZINTC0      = DGMBZ62C0
	#declare DGBZINTC1      = DGMBZ62C1
	#declare DGBZINTC2      = DGMBZ62C2
	#declare DGBZINTC3      = DGMBZ62C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength62  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 63)
	#declare DGBZINTC0      = DGMBZ63C0
	#declare DGBZINTC1      = DGMBZ63C1
	#declare DGBZINTC2      = DGMBZ63C2
	#declare DGBZINTC3      = DGMBZ63C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength63  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 64)
	#declare DGBZINTC0      = DGMBZ64C0
	#declare DGBZINTC1      = DGMBZ64C1
	#declare DGBZINTC2      = DGMBZ64C2
	#declare DGBZINTC3      = DGMBZ64C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength64  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 65)
	#declare DGBZINTC0      = DGMBZ65C0
	#declare DGBZINTC1      = DGMBZ65C1
	#declare DGBZINTC2      = DGMBZ65C2
	#declare DGBZINTC3      = DGMBZ65C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength65  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 66)
	#declare DGBZINTC0      = DGMBZ66C0
	#declare DGBZINTC1      = DGMBZ66C1
	#declare DGBZINTC2      = DGMBZ66C2
	#declare DGBZINTC3      = DGMBZ66C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength66  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 67)
	#declare DGBZINTC0      = DGMBZ67C0
	#declare DGBZINTC1      = DGMBZ67C1
	#declare DGBZINTC2      = DGMBZ67C2
	#declare DGBZINTC3      = DGMBZ67C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength67  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 68)
	#declare DGBZINTC0      = DGMBZ68C0
	#declare DGBZINTC1      = DGMBZ68C1
	#declare DGBZINTC2      = DGMBZ68C2
	#declare DGBZINTC3      = DGMBZ68C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength68  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 69)
	#declare DGBZINTC0      = DGMBZ69C0
	#declare DGBZINTC1      = DGMBZ69C1
	#declare DGBZINTC2      = DGMBZ69C2
	#declare DGBZINTC3      = DGMBZ69C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength69  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 70)
	#declare DGBZINTC0      = DGMBZ70C0
	#declare DGBZINTC1      = DGMBZ70C1
	#declare DGBZINTC2      = DGMBZ70C2
	#declare DGBZINTC3      = DGMBZ70C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength70  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 71)
	#declare DGBZINTC0      = DGMBZ71C0
	#declare DGBZINTC1      = DGMBZ71C1
	#declare DGBZINTC2      = DGMBZ71C2
	#declare DGBZINTC3      = DGMBZ71C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength71  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 72)
	#declare DGBZINTC0      = DGMBZ72C0
	#declare DGBZINTC1      = DGMBZ72C1
	#declare DGBZINTC2      = DGMBZ72C2
	#declare DGBZINTC3      = DGMBZ72C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength72  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 73)
	#declare DGBZINTC0      = DGMBZ73C0
	#declare DGBZINTC1      = DGMBZ73C1
	#declare DGBZINTC2      = DGMBZ73C2
	#declare DGBZINTC3      = DGMBZ73C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength73  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 74)
	#declare DGBZINTC0      = DGMBZ74C0
	#declare DGBZINTC1      = DGMBZ74C1
	#declare DGBZINTC2      = DGMBZ74C2
	#declare DGBZINTC3      = DGMBZ74C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength74  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 75)
	#declare DGBZINTC0      = DGMBZ75C0
	#declare DGBZINTC1      = DGMBZ75C1
	#declare DGBZINTC2      = DGMBZ75C2
	#declare DGBZINTC3      = DGMBZ75C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength75  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 76)
	#declare DGBZINTC0      = DGMBZ76C0
	#declare DGBZINTC1      = DGMBZ76C1
	#declare DGBZINTC2      = DGMBZ76C2
	#declare DGBZINTC3      = DGMBZ76C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength76  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 77)
	#declare DGBZINTC0      = DGMBZ77C0
	#declare DGBZINTC1      = DGMBZ77C1
	#declare DGBZINTC2      = DGMBZ77C2
	#declare DGBZINTC3      = DGMBZ77C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength77  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 78)
	#declare DGBZINTC0      = DGMBZ78C0
	#declare DGBZINTC1      = DGMBZ78C1
	#declare DGBZINTC2      = DGMBZ78C2
	#declare DGBZINTC3      = DGMBZ78C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength78  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 79)
	#declare DGBZINTC0      = DGMBZ79C0
	#declare DGBZINTC1      = DGMBZ79C1
	#declare DGBZINTC2      = DGMBZ79C2
	#declare DGBZINTC3      = DGMBZ79C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength79  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 80)
	#declare DGBZINTC0      = DGMBZ80C0
	#declare DGBZINTC1      = DGMBZ80C1
	#declare DGBZINTC2      = DGMBZ80C2
	#declare DGBZINTC3      = DGMBZ80C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength80  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 81)
	#declare DGBZINTC0      = DGMBZ81C0
	#declare DGBZINTC1      = DGMBZ81C1
	#declare DGBZINTC2      = DGMBZ81C2
	#declare DGBZINTC3      = DGMBZ81C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength81  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 82)
	#declare DGBZINTC0      = DGMBZ82C0
	#declare DGBZINTC1      = DGMBZ82C1
	#declare DGBZINTC2      = DGMBZ82C2
	#declare DGBZINTC3      = DGMBZ82C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength82  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 83)
	#declare DGBZINTC0      = DGMBZ83C0
	#declare DGBZINTC1      = DGMBZ83C1
	#declare DGBZINTC2      = DGMBZ83C2
	#declare DGBZINTC3      = DGMBZ83C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength83  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 84)
	#declare DGBZINTC0      = DGMBZ84C0
	#declare DGBZINTC1      = DGMBZ84C1
	#declare DGBZINTC2      = DGMBZ84C2
	#declare DGBZINTC3      = DGMBZ84C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength84  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 85)
	#declare DGBZINTC0      = DGMBZ85C0
	#declare DGBZINTC1      = DGMBZ85C1
	#declare DGBZINTC2      = DGMBZ85C2
	#declare DGBZINTC3      = DGMBZ85C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength85  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 86)
	#declare DGBZINTC0      = DGMBZ86C0
	#declare DGBZINTC1      = DGMBZ86C1
	#declare DGBZINTC2      = DGMBZ86C2
	#declare DGBZINTC3      = DGMBZ86C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength86  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 87)
	#declare DGBZINTC0      = DGMBZ87C0
	#declare DGBZINTC1      = DGMBZ87C1
	#declare DGBZINTC2      = DGMBZ87C2
	#declare DGBZINTC3      = DGMBZ87C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength87  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 88)
	#declare DGBZINTC0      = DGMBZ88C0
	#declare DGBZINTC1      = DGMBZ88C1
	#declare DGBZINTC2      = DGMBZ88C2
	#declare DGBZINTC3      = DGMBZ88C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength88  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 89)
	#declare DGBZINTC0      = DGMBZ89C0
	#declare DGBZINTC1      = DGMBZ89C1
	#declare DGBZINTC2      = DGMBZ89C2
	#declare DGBZINTC3      = DGMBZ89C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength89  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 90)
	#declare DGBZINTC0      = DGMBZ90C0
	#declare DGBZINTC1      = DGMBZ90C1
	#declare DGBZINTC2      = DGMBZ90C2
	#declare DGBZINTC3      = DGMBZ90C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength90  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 91)
	#declare DGBZINTC0      = DGMBZ91C0
	#declare DGBZINTC1      = DGMBZ91C1
	#declare DGBZINTC2      = DGMBZ91C2
	#declare DGBZINTC3      = DGMBZ91C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength91  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 92)
	#declare DGBZINTC0      = DGMBZ92C0
	#declare DGBZINTC1      = DGMBZ92C1
	#declare DGBZINTC2      = DGMBZ92C2
	#declare DGBZINTC3      = DGMBZ92C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength92  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 93)
	#declare DGBZINTC0      = DGMBZ93C0
	#declare DGBZINTC1      = DGMBZ93C1
	#declare DGBZINTC2      = DGMBZ93C2
	#declare DGBZINTC3      = DGMBZ93C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength93  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 94)
	#declare DGBZINTC0      = DGMBZ94C0
	#declare DGBZINTC1      = DGMBZ94C1
	#declare DGBZINTC2      = DGMBZ94C2
	#declare DGBZINTC3      = DGMBZ94C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength94  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 95)
	#declare DGBZINTC0      = DGMBZ95C0
	#declare DGBZINTC1      = DGMBZ95C1
	#declare DGBZINTC2      = DGMBZ95C2
	#declare DGBZINTC3      = DGMBZ95C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength95  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 96)
	#declare DGBZINTC0      = DGMBZ96C0
	#declare DGBZINTC1      = DGMBZ96C1
	#declare DGBZINTC2      = DGMBZ96C2
	#declare DGBZINTC3      = DGMBZ96C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength96  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 97)
	#declare DGBZINTC0      = DGMBZ97C0
	#declare DGBZINTC1      = DGMBZ97C1
	#declare DGBZINTC2      = DGMBZ97C2
	#declare DGBZINTC3      = DGMBZ97C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength97  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 98)
	#declare DGBZINTC0      = DGMBZ98C0
	#declare DGBZINTC1      = DGMBZ98C1
	#declare DGBZINTC2      = DGMBZ98C2
	#declare DGBZINTC3      = DGMBZ98C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength98  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
#if (DGMBZCurves >= 99)
	#declare DGBZINTC0      = DGMBZ99C0
	#declare DGBZINTC1      = DGMBZ99C1
	#declare DGBZINTC2      = DGMBZ99C2
	#declare DGBZINTC3      = DGMBZ99C3
	#declare DGBZINTCommand = 1
	#include "DGBZINT.INC"
	#declare DGMBZLength99  = DGBZINTLength
	#declare DGMBZTotal_Length = DGMBZTotal_Length + DGBZINTLength
#end
// --------------------------------------------------------


// --------------------------------------------------------
// Okay, now calculate the distance we need to find
// through the entire path
// --------------------------------------------------------
#declare DGMBZAmount_Through = DGMBZAmount * DGMBZTotal_Length
// --------------------------------------------------------


// --------------------------------------------------------
// Now let's find the correct curve in the path and then
// calculate the position
// --------------------------------------------------------
#declare DGMBZLength_So_Far = 0
#declare DGMBZFound         = false

#if ((DGMBZCurves >= 01) & (DGMBZFound = false))// then calculate this point - other wise to far through the curves
	// Find out if the point is in this segment
	#if (DGMBZAmount_Through <= (DGMBZLength_So_Far + DGMBZLength01))
		// we are in the correct segment
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through - DGMBZLength_So_Far) / DGMBZLength01
		#declare DGBZINTC0      = DGMBZ01C0
		#declare DGBZINTC1      = DGMBZ01C1
		#declare DGBZINTC2      = DGMBZ01C2
		#declare DGBZINTC3      = DGMBZ01C3
		#declare DGBZINTCommand = 2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		// not this segment
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far + DGMBZLength01
	#end
#end
#if ((DGMBZCurves >= 02) & (DGMBZFound = false))
	#if (DGMBZAmount_Through <= (DGMBZLength_So_Far + DGMBZLength02))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through - DGMBZLength_So_Far) / DGMBZLength02
		#declare DGBZINTC0             = DGMBZ02C0
		#declare DGBZINTC1             = DGMBZ02C1
		#declare DGBZINTC2             = DGMBZ02C2
		#declare DGBZINTC3             = DGMBZ02C3
		#declare DGBZINTCommand = 2
		#include "DGBZINT.INC"
		#declare DGMBZPosition  = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far + DGMBZLength02
	#end
#end
#if ((DGMBZCurves>=03)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength03))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength03
		#declare DGBZINTC0 = DGMBZ03C0
		#declare DGBZINTC1 = DGMBZ03C1
		#declare DGBZINTC2 = DGMBZ03C2
		#declare DGBZINTC3 = DGMBZ03C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength03
	#end
#end
#if ((DGMBZCurves>=04)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength04))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength04
		#declare DGBZINTC0 = DGMBZ04C0
		#declare DGBZINTC1 = DGMBZ04C1
		#declare DGBZINTC2 = DGMBZ04C2
		#declare DGBZINTC3 = DGMBZ04C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength04
	#end
#end
#if ((DGMBZCurves>=05)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength05))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength05
		#declare DGBZINTC0 = DGMBZ05C0
		#declare DGBZINTC1 = DGMBZ05C1
		#declare DGBZINTC2 = DGMBZ05C2
		#declare DGBZINTC3 = DGMBZ05C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength05
	#end
#end
#if ((DGMBZCurves>=06)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength06))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength06
		#declare DGBZINTC0 = DGMBZ06C0
		#declare DGBZINTC1 = DGMBZ06C1
		#declare DGBZINTC2 = DGMBZ06C2
		#declare DGBZINTC3 = DGMBZ06C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength06
	#end
#end
#if ((DGMBZCurves>=07)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength07))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength07
		#declare DGBZINTC0 = DGMBZ07C0
		#declare DGBZINTC1 = DGMBZ07C1
		#declare DGBZINTC2 = DGMBZ07C2
		#declare DGBZINTC3 = DGMBZ07C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength07
	#end
#end
#if ((DGMBZCurves>=08)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength08))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength08
		#declare DGBZINTC0 = DGMBZ08C0
		#declare DGBZINTC1 = DGMBZ08C1
		#declare DGBZINTC2 = DGMBZ08C2
		#declare DGBZINTC3 = DGMBZ08C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength08
	#end
#end
#if ((DGMBZCurves>=09)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength09))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength09
		#declare DGBZINTC0 = DGMBZ09C0
		#declare DGBZINTC1 = DGMBZ09C1
		#declare DGBZINTC2 = DGMBZ09C2
		#declare DGBZINTC3 = DGMBZ09C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength09
	#end
#end
#if ((DGMBZCurves>=10)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength10))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength10
		#declare DGBZINTC0 = DGMBZ10C0
		#declare DGBZINTC1 = DGMBZ10C1
		#declare DGBZINTC2 = DGMBZ10C2
		#declare DGBZINTC3 = DGMBZ10C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength10
	#end
#end
#if ((DGMBZCurves>=11)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength11))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength11
		#declare DGBZINTC0 = DGMBZ11C0
		#declare DGBZINTC1 = DGMBZ11C1
		#declare DGBZINTC2 = DGMBZ11C2
		#declare DGBZINTC3 = DGMBZ11C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength11
	#end
#end
#if ((DGMBZCurves>=12)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength12))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength12
		#declare DGBZINTC0 = DGMBZ12C0
		#declare DGBZINTC1 = DGMBZ12C1
		#declare DGBZINTC2 = DGMBZ12C2
		#declare DGBZINTC3 = DGMBZ12C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength12
	#end
#end
#if ((DGMBZCurves>=13)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength13))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength13
		#declare DGBZINTC0 = DGMBZ13C0
		#declare DGBZINTC1 = DGMBZ13C1
		#declare DGBZINTC2 = DGMBZ13C2
		#declare DGBZINTC3 = DGMBZ13C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength13
	#end
#end
#if ((DGMBZCurves>=14)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength14))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength14
		#declare DGBZINTC0 = DGMBZ14C0
		#declare DGBZINTC1 = DGMBZ14C1
		#declare DGBZINTC2 = DGMBZ14C2
		#declare DGBZINTC3 = DGMBZ14C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength14
	#end
#end
#if ((DGMBZCurves>=15)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength15))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength15
		#declare DGBZINTC0 = DGMBZ15C0
		#declare DGBZINTC1 = DGMBZ15C1
		#declare DGBZINTC2 = DGMBZ15C2
		#declare DGBZINTC3 = DGMBZ15C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength15
	#end
#end
#if ((DGMBZCurves>=16)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength16))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength16
		#declare DGBZINTC0 = DGMBZ16C0
		#declare DGBZINTC1 = DGMBZ16C1
		#declare DGBZINTC2 = DGMBZ16C2
		#declare DGBZINTC3 = DGMBZ16C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength16
	#end
#end
#if ((DGMBZCurves>=17)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength17))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength17
		#declare DGBZINTC0 = DGMBZ17C0
		#declare DGBZINTC1 = DGMBZ17C1
		#declare DGBZINTC2 = DGMBZ17C2
		#declare DGBZINTC3 = DGMBZ17C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength17
	#end
#end
#if ((DGMBZCurves>=18)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength18))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength18
		#declare DGBZINTC0 = DGMBZ18C0
		#declare DGBZINTC1 = DGMBZ18C1
		#declare DGBZINTC2 = DGMBZ18C2
		#declare DGBZINTC3 = DGMBZ18C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength18
	#end
#end
#if ((DGMBZCurves>=19)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength19))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength19
		#declare DGBZINTC0 = DGMBZ19C0
		#declare DGBZINTC1 = DGMBZ19C1
		#declare DGBZINTC2 = DGMBZ19C2
		#declare DGBZINTC3 = DGMBZ19C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength19
	#end
#end
#if ((DGMBZCurves>=20)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength20))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength20
		#declare DGBZINTC0 = DGMBZ20C0
		#declare DGBZINTC1 = DGMBZ20C1
		#declare DGBZINTC2 = DGMBZ20C2
		#declare DGBZINTC3 = DGMBZ20C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength20
	#end
#end
#if ((DGMBZCurves>=21)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength21))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength21
		#declare DGBZINTC0 = DGMBZ21C0
		#declare DGBZINTC1 = DGMBZ21C1
		#declare DGBZINTC2 = DGMBZ21C2
		#declare DGBZINTC3 = DGMBZ21C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength21
	#end
#end
#if ((DGMBZCurves>=22)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength22))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength22
		#declare DGBZINTC0 = DGMBZ22C0
		#declare DGBZINTC1 = DGMBZ22C1
		#declare DGBZINTC2 = DGMBZ22C2
		#declare DGBZINTC3 = DGMBZ22C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength22
	#end
#end
#if ((DGMBZCurves>=23)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength23))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength23
		#declare DGBZINTC0 = DGMBZ23C0
		#declare DGBZINTC1 = DGMBZ23C1
		#declare DGBZINTC2 = DGMBZ23C2
		#declare DGBZINTC3 = DGMBZ23C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength23
	#end
#end
#if ((DGMBZCurves>=24)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength24))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength24
		#declare DGBZINTC0 = DGMBZ24C0
		#declare DGBZINTC1 = DGMBZ24C1
		#declare DGBZINTC2 = DGMBZ24C2
		#declare DGBZINTC3 = DGMBZ24C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength24
	#end
#end
#if ((DGMBZCurves>=25)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength25))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength25
		#declare DGBZINTC0 = DGMBZ25C0
		#declare DGBZINTC1 = DGMBZ25C1
		#declare DGBZINTC2 = DGMBZ25C2
		#declare DGBZINTC3 = DGMBZ25C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength25
	#end
#end
#if ((DGMBZCurves>=26)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength26))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength26
		#declare DGBZINTC0 = DGMBZ26C0
		#declare DGBZINTC1 = DGMBZ26C1
		#declare DGBZINTC2 = DGMBZ26C2
		#declare DGBZINTC3 = DGMBZ26C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength26
	#end
#end
#if ((DGMBZCurves>=27)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength27))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength27
		#declare DGBZINTC0 = DGMBZ27C0
		#declare DGBZINTC1 = DGMBZ27C1
		#declare DGBZINTC2 = DGMBZ27C2
		#declare DGBZINTC3 = DGMBZ27C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength27
	#end
#end
#if ((DGMBZCurves>=28)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength28))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength28
		#declare DGBZINTC0 = DGMBZ28C0
		#declare DGBZINTC1 = DGMBZ28C1
		#declare DGBZINTC2 = DGMBZ28C2
		#declare DGBZINTC3 = DGMBZ28C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength28
	#end
#end
#if ((DGMBZCurves>=29)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength29))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength29
		#declare DGBZINTC0 = DGMBZ29C0
		#declare DGBZINTC1 = DGMBZ29C1
		#declare DGBZINTC2 = DGMBZ29C2
		#declare DGBZINTC3 = DGMBZ29C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength29
	#end
#end
#if ((DGMBZCurves>=30)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength30))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength30
		#declare DGBZINTC0 = DGMBZ30C0
		#declare DGBZINTC1 = DGMBZ30C1
		#declare DGBZINTC2 = DGMBZ30C2
		#declare DGBZINTC3 = DGMBZ30C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength30
	#end
#end
#if ((DGMBZCurves>=31)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength31))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength31
		#declare DGBZINTC0 = DGMBZ31C0
		#declare DGBZINTC1 = DGMBZ31C1
		#declare DGBZINTC2 = DGMBZ31C2
		#declare DGBZINTC3 = DGMBZ31C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength31
	#end
#end
#if ((DGMBZCurves>=32)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength32))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength32
		#declare DGBZINTC0 = DGMBZ32C0
		#declare DGBZINTC1 = DGMBZ32C1
		#declare DGBZINTC2 = DGMBZ32C2
		#declare DGBZINTC3 = DGMBZ32C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength32
	#end
#end
#if ((DGMBZCurves>=33)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength33))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength33
		#declare DGBZINTC0 = DGMBZ33C0
		#declare DGBZINTC1 = DGMBZ33C1
		#declare DGBZINTC2 = DGMBZ33C2
		#declare DGBZINTC3 = DGMBZ33C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength33
	#end
#end
#if ((DGMBZCurves>=34)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength34))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength34
		#declare DGBZINTC0 = DGMBZ34C0
		#declare DGBZINTC1 = DGMBZ34C1
		#declare DGBZINTC2 = DGMBZ34C2
		#declare DGBZINTC3 = DGMBZ34C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength34
	#end
#end
#if ((DGMBZCurves>=35)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength35))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength35
		#declare DGBZINTC0 = DGMBZ35C0
		#declare DGBZINTC1 = DGMBZ35C1
		#declare DGBZINTC2 = DGMBZ35C2
		#declare DGBZINTC3 = DGMBZ35C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength35
	#end
#end
#if ((DGMBZCurves>=36)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength36))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength36
		#declare DGBZINTC0 = DGMBZ36C0
		#declare DGBZINTC1 = DGMBZ36C1
		#declare DGBZINTC2 = DGMBZ36C2
		#declare DGBZINTC3 = DGMBZ36C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength36
	#end
#end
#if ((DGMBZCurves>=37)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength37))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength37
		#declare DGBZINTC0 = DGMBZ37C0
		#declare DGBZINTC1 = DGMBZ37C1
		#declare DGBZINTC2 = DGMBZ37C2
		#declare DGBZINTC3 = DGMBZ37C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength37
	#end
#end
#if ((DGMBZCurves>=38)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength38))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength38
		#declare DGBZINTC0 = DGMBZ38C0
		#declare DGBZINTC1 = DGMBZ38C1
		#declare DGBZINTC2 = DGMBZ38C2
		#declare DGBZINTC3 = DGMBZ38C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength38
	#end
#end
#if ((DGMBZCurves>=39)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength39))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength39
		#declare DGBZINTC0 = DGMBZ39C0
		#declare DGBZINTC1 = DGMBZ39C1
		#declare DGBZINTC2 = DGMBZ39C2
		#declare DGBZINTC3 = DGMBZ39C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength39
	#end
#end
#if ((DGMBZCurves>=40)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength40))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength40
		#declare DGBZINTC0 = DGMBZ40C0
		#declare DGBZINTC1 = DGMBZ40C1
		#declare DGBZINTC2 = DGMBZ40C2
		#declare DGBZINTC3 = DGMBZ40C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength40
	#end
#end
#if ((DGMBZCurves>=41)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength41))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength41
		#declare DGBZINTC0 = DGMBZ41C0
		#declare DGBZINTC1 = DGMBZ41C1
		#declare DGBZINTC2 = DGMBZ41C2
		#declare DGBZINTC3 = DGMBZ41C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength41
	#end
#end
#if ((DGMBZCurves>=42)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength42))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength42
		#declare DGBZINTC0 = DGMBZ42C0
		#declare DGBZINTC1 = DGMBZ42C1
		#declare DGBZINTC2 = DGMBZ42C2
		#declare DGBZINTC3 = DGMBZ42C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength42
	#end
#end
#if ((DGMBZCurves>=43)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength43))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength43
		#declare DGBZINTC0 = DGMBZ43C0
		#declare DGBZINTC1 = DGMBZ43C1
		#declare DGBZINTC2 = DGMBZ43C2
		#declare DGBZINTC3 = DGMBZ43C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength43
	#end
#end
#if ((DGMBZCurves>=44)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength44))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength44
		#declare DGBZINTC0 = DGMBZ44C0
		#declare DGBZINTC1 = DGMBZ44C1
		#declare DGBZINTC2 = DGMBZ44C2
		#declare DGBZINTC3 = DGMBZ44C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength44
	#end
#end
#if ((DGMBZCurves>=45)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength45))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength45
		#declare DGBZINTC0 = DGMBZ45C0
		#declare DGBZINTC1 = DGMBZ45C1
		#declare DGBZINTC2 = DGMBZ45C2
		#declare DGBZINTC3 = DGMBZ45C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength45
	#end
#end
#if ((DGMBZCurves>=46)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength46))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength46
		#declare DGBZINTC0 = DGMBZ46C0
		#declare DGBZINTC1 = DGMBZ46C1
		#declare DGBZINTC2 = DGMBZ46C2
		#declare DGBZINTC3 = DGMBZ46C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength46
	#end
#end
#if ((DGMBZCurves>=47)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength47))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength47
		#declare DGBZINTC0 = DGMBZ47C0
		#declare DGBZINTC1 = DGMBZ47C1
		#declare DGBZINTC2 = DGMBZ47C2
		#declare DGBZINTC3 = DGMBZ47C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength47
	#end
#end
#if ((DGMBZCurves>=48)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength48))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength48
		#declare DGBZINTC0 = DGMBZ48C0
		#declare DGBZINTC1 = DGMBZ48C1
		#declare DGBZINTC2 = DGMBZ48C2
		#declare DGBZINTC3 = DGMBZ48C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength48
	#end
#end
#if ((DGMBZCurves>=49)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength49))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength49
		#declare DGBZINTC0 = DGMBZ49C0
		#declare DGBZINTC1 = DGMBZ49C1
		#declare DGBZINTC2 = DGMBZ49C2
		#declare DGBZINTC3 = DGMBZ49C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength49
	#end
#end
#if ((DGMBZCurves>=50)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength50))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength50
		#declare DGBZINTC0 = DGMBZ50C0
		#declare DGBZINTC1 = DGMBZ50C1
		#declare DGBZINTC2 = DGMBZ50C2
		#declare DGBZINTC3 = DGMBZ50C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength50
	#end
#end
#if ((DGMBZCurves>=51)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength51))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength51
		#declare DGBZINTC0 = DGMBZ51C0
		#declare DGBZINTC1 = DGMBZ51C1
		#declare DGBZINTC2 = DGMBZ51C2
		#declare DGBZINTC3 = DGMBZ51C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength51
	#end
#end
#if ((DGMBZCurves>=52)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength52))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength52
		#declare DGBZINTC0 = DGMBZ52C0
		#declare DGBZINTC1 = DGMBZ52C1
		#declare DGBZINTC2 = DGMBZ52C2
		#declare DGBZINTC3 = DGMBZ52C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength52
	#end
#end
#if ((DGMBZCurves>=53)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength53))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength53
		#declare DGBZINTC0 = DGMBZ53C0
		#declare DGBZINTC1 = DGMBZ53C1
		#declare DGBZINTC2 = DGMBZ53C2
		#declare DGBZINTC3 = DGMBZ53C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength53
	#end
#end
#if ((DGMBZCurves>=54)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength54))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength54
		#declare DGBZINTC0 = DGMBZ54C0
		#declare DGBZINTC1 = DGMBZ54C1
		#declare DGBZINTC2 = DGMBZ54C2
		#declare DGBZINTC3 = DGMBZ54C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength54
	#end
#end
#if ((DGMBZCurves>=55)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength55))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength55
		#declare DGBZINTC0 = DGMBZ55C0
		#declare DGBZINTC1 = DGMBZ55C1
		#declare DGBZINTC2 = DGMBZ55C2
		#declare DGBZINTC3 = DGMBZ55C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength55
	#end
#end
#if ((DGMBZCurves>=56)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength56))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength56
		#declare DGBZINTC0 = DGMBZ56C0
		#declare DGBZINTC1 = DGMBZ56C1
		#declare DGBZINTC2 = DGMBZ56C2
		#declare DGBZINTC3 = DGMBZ56C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength56
	#end
#end
#if ((DGMBZCurves>=57)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength57))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength57
		#declare DGBZINTC0 = DGMBZ57C0
		#declare DGBZINTC1 = DGMBZ57C1
		#declare DGBZINTC2 = DGMBZ57C2
		#declare DGBZINTC3 = DGMBZ57C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength57
	#end
#end
#if ((DGMBZCurves>=58)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength58))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength58
		#declare DGBZINTC0 = DGMBZ58C0
		#declare DGBZINTC1 = DGMBZ58C1
		#declare DGBZINTC2 = DGMBZ58C2
		#declare DGBZINTC3 = DGMBZ58C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength58
	#end
#end
#if ((DGMBZCurves>=59)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength59))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength59
		#declare DGBZINTC0 = DGMBZ59C0
		#declare DGBZINTC1 = DGMBZ59C1
		#declare DGBZINTC2 = DGMBZ59C2
		#declare DGBZINTC3 = DGMBZ59C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength59
	#end
#end
#if ((DGMBZCurves>=60)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength60))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength60
		#declare DGBZINTC0 = DGMBZ60C0
		#declare DGBZINTC1 = DGMBZ60C1
		#declare DGBZINTC2 = DGMBZ60C2
		#declare DGBZINTC3 = DGMBZ60C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength60
	#end
#end
#if ((DGMBZCurves>=61)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength61))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength61
		#declare DGBZINTC0 = DGMBZ61C0
		#declare DGBZINTC1 = DGMBZ61C1
		#declare DGBZINTC2 = DGMBZ61C2
		#declare DGBZINTC3 = DGMBZ61C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength61
	#end
#end
#if ((DGMBZCurves>=62)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength62))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength62
		#declare DGBZINTC0 = DGMBZ62C0
		#declare DGBZINTC1 = DGMBZ62C1
		#declare DGBZINTC2 = DGMBZ62C2
		#declare DGBZINTC3 = DGMBZ62C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength62
	#end
#end
#if ((DGMBZCurves>=63)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength63))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength63
		#declare DGBZINTC0 = DGMBZ63C0
		#declare DGBZINTC1 = DGMBZ63C1
		#declare DGBZINTC2 = DGMBZ63C2
		#declare DGBZINTC3 = DGMBZ63C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength63
	#end
#end
#if ((DGMBZCurves>=64)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength64))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength64
		#declare DGBZINTC0 = DGMBZ64C0
		#declare DGBZINTC1 = DGMBZ64C1
		#declare DGBZINTC2 = DGMBZ64C2
		#declare DGBZINTC3 = DGMBZ64C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength64
	#end
#end
#if ((DGMBZCurves>=65)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength65))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength65
		#declare DGBZINTC0 = DGMBZ65C0
		#declare DGBZINTC1 = DGMBZ65C1
		#declare DGBZINTC2 = DGMBZ65C2
		#declare DGBZINTC3 = DGMBZ65C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength65
	#end
#end
#if ((DGMBZCurves>=66)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength66))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength66
		#declare DGBZINTC0 = DGMBZ66C0
		#declare DGBZINTC1 = DGMBZ66C1
		#declare DGBZINTC2 = DGMBZ66C2
		#declare DGBZINTC3 = DGMBZ66C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength66
	#end
#end
#if ((DGMBZCurves>=67)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength67))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength67
		#declare DGBZINTC0 = DGMBZ67C0
		#declare DGBZINTC1 = DGMBZ67C1
		#declare DGBZINTC2 = DGMBZ67C2
		#declare DGBZINTC3 = DGMBZ67C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength67
	#end
#end
#if ((DGMBZCurves>=68)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength68))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength68
		#declare DGBZINTC0 = DGMBZ68C0
		#declare DGBZINTC1 = DGMBZ68C1
		#declare DGBZINTC2 = DGMBZ68C2
		#declare DGBZINTC3 = DGMBZ68C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength68
	#end
#end
#if ((DGMBZCurves>=69)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength69))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength69
		#declare DGBZINTC0 = DGMBZ69C0
		#declare DGBZINTC1 = DGMBZ69C1
		#declare DGBZINTC2 = DGMBZ69C2
		#declare DGBZINTC3 = DGMBZ69C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength69
	#end
#end
#if ((DGMBZCurves>=70)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength70))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength70
		#declare DGBZINTC0 = DGMBZ70C0
		#declare DGBZINTC1 = DGMBZ70C1
		#declare DGBZINTC2 = DGMBZ70C2
		#declare DGBZINTC3 = DGMBZ70C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength70
	#end
#end
#if ((DGMBZCurves>=71)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength71))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength71
		#declare DGBZINTC0 = DGMBZ71C0
		#declare DGBZINTC1 = DGMBZ71C1
		#declare DGBZINTC2 = DGMBZ71C2
		#declare DGBZINTC3 = DGMBZ71C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength71
	#end
#end
#if ((DGMBZCurves>=72)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength72))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength72
		#declare DGBZINTC0 = DGMBZ72C0
		#declare DGBZINTC1 = DGMBZ72C1
		#declare DGBZINTC2 = DGMBZ72C2
		#declare DGBZINTC3 = DGMBZ72C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength72
	#end
#end
#if ((DGMBZCurves>=73)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength73))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength73
		#declare DGBZINTC0 = DGMBZ73C0
		#declare DGBZINTC1 = DGMBZ73C1
		#declare DGBZINTC2 = DGMBZ73C2
		#declare DGBZINTC3 = DGMBZ73C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength73
	#end
#end
#if ((DGMBZCurves>=74)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength74))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength74
		#declare DGBZINTC0 = DGMBZ74C0
		#declare DGBZINTC1 = DGMBZ74C1
		#declare DGBZINTC2 = DGMBZ74C2
		#declare DGBZINTC3 = DGMBZ74C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength74
	#end
#end
#if ((DGMBZCurves>=75)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength75))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength75
		#declare DGBZINTC0 = DGMBZ75C0
		#declare DGBZINTC1 = DGMBZ75C1
		#declare DGBZINTC2 = DGMBZ75C2
		#declare DGBZINTC3 = DGMBZ75C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength75
	#end
#end
#if ((DGMBZCurves>=76)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength76))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength76
		#declare DGBZINTC0 = DGMBZ76C0
		#declare DGBZINTC1 = DGMBZ76C1
		#declare DGBZINTC2 = DGMBZ76C2
		#declare DGBZINTC3 = DGMBZ76C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength76
	#end
#end
#if ((DGMBZCurves>=77)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength77))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength77
		#declare DGBZINTC0 = DGMBZ77C0
		#declare DGBZINTC1 = DGMBZ77C1
		#declare DGBZINTC2 = DGMBZ77C2
		#declare DGBZINTC3 = DGMBZ77C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength77
	#end
#end
#if ((DGMBZCurves>=78)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength78))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength78
		#declare DGBZINTC0 = DGMBZ78C0
		#declare DGBZINTC1 = DGMBZ78C1
		#declare DGBZINTC2 = DGMBZ78C2
		#declare DGBZINTC3 = DGMBZ78C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength78
	#end
#end
#if ((DGMBZCurves>=79)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength79))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength79
		#declare DGBZINTC0 = DGMBZ79C0
		#declare DGBZINTC1 = DGMBZ79C1
		#declare DGBZINTC2 = DGMBZ79C2
		#declare DGBZINTC3 = DGMBZ79C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength79
	#end
#end
#if ((DGMBZCurves>=80)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength80))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength80
		#declare DGBZINTC0 = DGMBZ80C0
		#declare DGBZINTC1 = DGMBZ80C1
		#declare DGBZINTC2 = DGMBZ80C2
		#declare DGBZINTC3 = DGMBZ80C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength80
	#end
#end
#if ((DGMBZCurves>=81)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength81))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength81
		#declare DGBZINTC0 = DGMBZ81C0
		#declare DGBZINTC1 = DGMBZ81C1
		#declare DGBZINTC2 = DGMBZ81C2
		#declare DGBZINTC3 = DGMBZ81C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength81
	#end
#end
#if ((DGMBZCurves>=82)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength82))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength82
		#declare DGBZINTC0 = DGMBZ82C0
		#declare DGBZINTC1 = DGMBZ82C1
		#declare DGBZINTC2 = DGMBZ82C2
		#declare DGBZINTC3 = DGMBZ82C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength82
	#end
#end
#if ((DGMBZCurves>=83)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength83))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength83
		#declare DGBZINTC0 = DGMBZ83C0
		#declare DGBZINTC1 = DGMBZ83C1
		#declare DGBZINTC2 = DGMBZ83C2
		#declare DGBZINTC3 = DGMBZ83C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength83
	#end
#end
#if ((DGMBZCurves>=84)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength84))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength84
		#declare DGBZINTC0 = DGMBZ84C0
		#declare DGBZINTC1 = DGMBZ84C1
		#declare DGBZINTC2 = DGMBZ84C2
		#declare DGBZINTC3 = DGMBZ84C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength84
	#end
#end
#if ((DGMBZCurves>=85)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength85))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength85
		#declare DGBZINTC0 = DGMBZ85C0
		#declare DGBZINTC1 = DGMBZ85C1
		#declare DGBZINTC2 = DGMBZ85C2
		#declare DGBZINTC3 = DGMBZ85C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength85
	#end
#end
#if ((DGMBZCurves>=86)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength86))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength86
		#declare DGBZINTC0 = DGMBZ86C0
		#declare DGBZINTC1 = DGMBZ86C1
		#declare DGBZINTC2 = DGMBZ86C2
		#declare DGBZINTC3 = DGMBZ86C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength86
	#end
#end
#if ((DGMBZCurves>=87)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength87))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength87
		#declare DGBZINTC0 = DGMBZ87C0
		#declare DGBZINTC1 = DGMBZ87C1
		#declare DGBZINTC2 = DGMBZ87C2
		#declare DGBZINTC3 = DGMBZ87C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength87
	#end
#end
#if ((DGMBZCurves>=88)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength88))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength88
		#declare DGBZINTC0 = DGMBZ88C0
		#declare DGBZINTC1 = DGMBZ88C1
		#declare DGBZINTC2 = DGMBZ88C2
		#declare DGBZINTC3 = DGMBZ88C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength88
	#end
#end
#if ((DGMBZCurves>=89)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength89))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength89
		#declare DGBZINTC0 = DGMBZ89C0
		#declare DGBZINTC1 = DGMBZ89C1
		#declare DGBZINTC2 = DGMBZ89C2
		#declare DGBZINTC3 = DGMBZ89C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength89
	#end
#end
#if ((DGMBZCurves>=90)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength90))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength90
		#declare DGBZINTC0 = DGMBZ90C0
		#declare DGBZINTC1 = DGMBZ90C1
		#declare DGBZINTC2 = DGMBZ90C2
		#declare DGBZINTC3 = DGMBZ90C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength90
	#end
#end
#if ((DGMBZCurves>=91)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength91))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength91
		#declare DGBZINTC0 = DGMBZ91C0
		#declare DGBZINTC1 = DGMBZ91C1
		#declare DGBZINTC2 = DGMBZ91C2
		#declare DGBZINTC3 = DGMBZ91C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength91
	#end
#end
#if ((DGMBZCurves>=92)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength92))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength92
		#declare DGBZINTC0 = DGMBZ92C0
		#declare DGBZINTC1 = DGMBZ92C1
		#declare DGBZINTC2 = DGMBZ92C2
		#declare DGBZINTC3 = DGMBZ92C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength92
	#end
#end
#if ((DGMBZCurves>=93)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength93))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength93
		#declare DGBZINTC0 = DGMBZ93C0
		#declare DGBZINTC1 = DGMBZ93C1
		#declare DGBZINTC2 = DGMBZ93C2
		#declare DGBZINTC3 = DGMBZ93C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength93
	#end
#end
#if ((DGMBZCurves>=94)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength94))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength94
		#declare DGBZINTC0 = DGMBZ94C0
		#declare DGBZINTC1 = DGMBZ94C1
		#declare DGBZINTC2 = DGMBZ94C2
		#declare DGBZINTC3 = DGMBZ94C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength94
	#end
#end
#if ((DGMBZCurves>=95)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength95))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength95
		#declare DGBZINTC0 = DGMBZ95C0
		#declare DGBZINTC1 = DGMBZ95C1
		#declare DGBZINTC2 = DGMBZ95C2
		#declare DGBZINTC3 = DGMBZ95C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength95
	#end
#end
#if ((DGMBZCurves>=96)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength96))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength96
		#declare DGBZINTC0 = DGMBZ96C0
		#declare DGBZINTC1 = DGMBZ96C1
		#declare DGBZINTC2 = DGMBZ96C2
		#declare DGBZINTC3 = DGMBZ96C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength96
	#end
#end
#if ((DGMBZCurves>=97)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength97))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength97
		#declare DGBZINTC0 = DGMBZ97C0
		#declare DGBZINTC1 = DGMBZ97C1
		#declare DGBZINTC2 = DGMBZ97C2
		#declare DGBZINTC3 = DGMBZ97C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength97
	#end
#end
#if ((DGMBZCurves>=98)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength98))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength98
		#declare DGBZINTC0 = DGMBZ98C0
		#declare DGBZINTC1 = DGMBZ98C1
		#declare DGBZINTC2 = DGMBZ98C2
		#declare DGBZINTC3 = DGMBZ98C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength98
	#end
#end
#if ((DGMBZCurves>=99)&(DGMBZFound=false))
	#if (DGMBZAmount_Through<=(DGMBZLength_So_Far+DGMBZLength99))
		#declare DGBZINTCurve_Position = (DGMBZAmount_Through-DGMBZLength_So_Far)/DGMBZLength99
		#declare DGBZINTC0 = DGMBZ99C0
		#declare DGBZINTC1 = DGMBZ99C1
		#declare DGBZINTC2 = DGMBZ99C2
		#declare DGBZINTC3 = DGMBZ99C3
		#declare DGBZINTCommand =2
		#include "DGBZINT.INC"
		#declare DGMBZPosition = DGBZINTPosition
		#declare DGMBZFound = true
	#else
		#declare DGMBZLength_So_Far = DGMBZLength_So_Far+DGMBZLength99
	#end
#end


